#!/usr/bin/python
# -*- encoding: utf-8 -*-

import RPi.GPIO as GPIO
import time
import os
import random



GPIO.setwarnings(False)
GPIO.setmode(GPIO.BCM)



# instalace ServoBlasteru
try:              # pokus o otevreni souboru /dev/servoblaster
  with open("/dev/servoblaster"): pass

except IOError:   # pokud soubor neexistuje, znamena to, ze pravdepodobne neni nainstalovany modul servoblaster 
  print "Servoblaster je treba nainstalovat"
  print " ... INSTALUJI ..."

  prikaz = "sudo insmod /home/pi/PiBits/ServoBlaster/servoblaster.ko"
  os.system(prikaz)           # vykonani prikazu insmod....

  with open("/proc/devices") as f:       # zjisteni cisla servoblasteru ze souboru /proc/devices
    for radka in f :
      if (radka.find("servoblaster")>0):
        mezera = radka.find(" ")    
        cislo = radka[:mezera]
        print "cislo servoblasteru je :" + str(cislo)

  prikaz = "sudo mknod -m 0666 /dev/servoblaster c " + str(cislo) + " 0"
  os.system(prikaz)          # vykonani prikazu mknod ....



print "Servoblaster je nainstalovany."



kanal_h = 1            # kanal pro rizeni horizontalniho serva - 1 = GPIO17 (= hw pin 11)
kanal_v = 2            # kanal pro rizeni vertikalniho serva   - 2 = GPIO18 (= hw pin 12)

# cisla vsech kanalu a jejich prirazeni GPIO pinum: 
#     Servo number    GPIO number   Pin in P1 header
#           0               4             P1-7
#           1              17             P1-11
#           2              18             P1-12
#           3              21             P1-13
#           4              22             P1-15
#           5              23             P1-16
#           6              24             P1-18
#           7              25             P1-22




while True:

  # v prikladu se pro nataceni serv generuji nahodna cisla v rozsahu 1ms az 2ms (cisla 100 az 200)
  horiz = random.randint(100, 200)   # sirka pulzu pro horizontalni servo (cislo 50 az 250 odpovida casu 0.5ms az 2.5ms)
  vert  = random.randint(100, 200)   # sirka pulzu pro vertikln servo (cislo 50 az 250 odpovida casu 0.5ms az 2.5ms)

  prikaz_h="echo " + str(kanal_h) + "=" + str(horiz) +" > /dev/servoblaster"  # zapnuti horizontalniho serva s parametrem sirky impulzu
  os.system(prikaz_h)
  prikaz_v="echo " + str(kanal_v) + "=" + str(vert) +" > /dev/servoblaster" # zapnuti vertikalniho serva s parametrem sirky impulzu
  os.system(prikaz_v)

  time.sleep(1)     # jedna sekunda je dostatecne dlouha doba na najeti obou serv na pozadovanou pozici

  prikaz_h="echo " + str(kanal_h) + "=0 > /dev/servoblaster"   # vypnuti horizontalniho serva
  os.system(prikaz_h)
  prikaz_v="echo " + str(kanal_v) + "=0 > /dev/servoblaster"   # vypnuti vertikalniho serva
  os.system(prikaz_v)



  # na zaver dojde k vystrelu davky laserem
  laser_pin = 7                          # GPIO7 (= hw pin 26)
  GPIO.setup(laser_pin, GPIO.OUT)        # GPIO pro ovladani laseru prepne na vystup
  signal3 = GPIO.PWM(laser_pin , 5)      # frekvence (kadence) vystrelu 5Hz 
  signal3.start(20)                      # palba (50% strida)
  time.sleep(2)
  signal3.stop()                         # po 2 sekundach se palba zastavi
  GPIO.output(laser_pin, False)          # pro jistotu se laser vypne



